
import Cp

infix 4  |->
x |-> y = (x,y)

data PTree = Node {
        name   :: [ Char ]    ,
        birth  :: Int         ,
        mother :: Maybe PTree ,
        father :: Maybe PTree
        } deriving (Show,Eq)

inPTree((n,b),m,f) = Node n b m f
outPTree(Node n b m f) = ((n,b),m,f)
basePTree f h (x,m,p) = (f x, fmap h m, fmap h p)
anaPTree f = inPTree . (basePTree id (anaPTree f)) . f

hmother getMother t = mother t

l =	Node "Luigi" 1920 Nothing Nothing
m =	Node "Margaret" 1923 Nothing Nothing
j=	Node "Joseph" 1955 (Just m) (Just l)
n=	Node "Mary" 1956 Nothing (Just a)
t=	Node "Peter" 1991 (Just n) (Just j)
--
a=	Node "Jules" 1917 Nothing Nothing

data Heap a k = Heap [(k,(a,Maybe k, Maybe k))] k deriving Show

instance BiFunctor Heap
         where bmap g f (Heap h k') =
                   Heap [ (f k) |-> (g a, fmap f p, fmap f p') | (k,(a,p,p')) <- h ] (f k')

get (Just h1) = h1
get Nothing   = Heap [] []

{--
merge a x y =
	let (Heap h1 k1) = bmap id (1:) (get x)
            (Heap h2 k2) = bmap id (2:) (get y)
        in Heap ([ [] |-> (a, Just k1, Just k2) ] ++ h1 ++ h2) []

merge a Nothing Nothing  = Heap ([ [] |-> (a, Nothing, Nothing) ]) []
merge a Nothing (Just x) = Heap ([ [] |-> (a, Nothing, Just k2) ] ++ h2) []
                             where (Heap h2 k2) = bmap id (2:) x
merge a (Just x) Nothing = Heap ([ [] |-> (a, Just k1, Nothing) ] ++ h1) []
                             where (Heap h1 k1) = bmap id (1:) x
merge a (Just x) (Just y) = Heap ([ [] |-> (a, Just k1, Just k2) ] ++ h1 ++ h2) []
                             where (Heap h1 k1) = bmap id (1:) x
                                   (Heap h2 k2) = bmap id (2:) y
--}

even_ n = 2*n
odd_  n = 2*n+1

merge a Nothing Nothing  = Heap ([ 1 |-> (a, Nothing, Nothing) ]) 1
merge a Nothing (Just x) = Heap ([ 1 |-> (a, Nothing, Just k2) ] ++ h2) 1
                             where (Heap h2 k2) = bmap id odd_ x
merge a (Just x) Nothing = Heap ([ 1 |-> (a, Just k1, Nothing) ] ++ h1) 1
                             where (Heap h1 k1) = bmap id even_ x
merge a (Just x) (Just y) = Heap ([ 1 |-> (a, Just k1, Just k2) ] ++ h1 ++ h2) 1
                             where (Heap h1 k1) = bmap id even_ x
                                   (Heap h2 k2) = bmap id odd_ y

r (Node n b m f) = let x = fmap r m
                       y = fmap r f
                   in merge (n,b) x y

-- rm (Node n b m f) = do k <- get ;
--                        put(k+1) ;
--                        x <- rm m;
--                        y <- rm f;
--                        return merge (n,b) x y

-- Maybe function for abstraction f

f(Heap h k) = do { (a,x,y) <- lookup k h;
                    aux h a x y
                 }

aux h a Nothing Nothing =
        return (Node (fst a)(snd a) Nothing Nothing)
aux h a (Just x) (Just y) =
        do { t   <- f (Heap h x);
             t'  <- f (Heap h y);
             return (Node (fst a)(snd a) (Just t) (Just t'))
           }
aux h a Nothing (Just y) =
        do { t'  <- f (Heap h y);
             return (Node (fst a)(snd a) Nothing (Just t'))
           }
aux h a (Just x) Nothing =
        do { t   <- f (Heap h x);
             return (Node (fst a)(snd a) (Just t) Nothing)
           }

-- Abstraction function really partial
absf (Heap h k) = let Just (a,x,y) = lookup k h
                  in  Node (fst a)(snd a)
                           (fmap (absf . Heap h) x)
                           (fmap (absf . Heap h) y)

-- faulty heap
h :: Heap ([Char], Int) Int
h = Heap [(1,(("Peter",1991),Just 2,Just 3)),
          (2,(("Mary",1956),Nothing,Just 6)),
          (6,(("Jules",1917),Nothing,Nothing)),
          (3,(("Joseph",1955),Just 5,Just 1)),
          (5,(("Margaret",1923),Nothing,Nothing)),
          (7,(("Luigi",1920),Nothing,Nothing))] 1

